Summary: A systems administration tool for networks
Name: cfengine
Version: 3.2.4
Release: 2
License: GPLv2+
Group: Applications/System
Source0: ftp://ftp.iu.hio.no/pub/cfengine/%{name}-%{version}.tar.gz
Source1: cf-execd.aix.init
Source2: cf-monitord.aix.init
Source3: cf-serverd.aix.init
Patch0: %{name}-%{version}-aix.patch
URL: http://www.cfengine.org/
BuildRoot: %{_tmppath}/%{name}-%{version}-%{release}-root

BuildRequires: bison, flex, m4
BuildRequires: db4-devel >= 4.7.25-2, openssl-devel >= 0.9.8, pcre-devel >= 7.9

Requires: db4 >= 4.7.25-2, openssl >= 0.9.8, pcre >= 7.9

%description
Cfengine, or the configuration engine is an agent/software robot and a
very high level language for building expert systems to administrate
and configure large computer networks. Cfengine uses the idea of
classes and a primitive form of intelligence to define and automate
the configuration and maintenance of system state, for small to huge
configurations. Cfengine is designed to be a part of a computer immune
system.


%package doc
Summary: Documentation for cfengine
Group: Documentation
Requires: %{name} = %{version}-%{release}

%description doc
This package contains the documentation for cfengine.


%prep
%setup -q
%patch0


%build
export CONFIG_SHELL=/usr/bin/ksh
export CONFIG_ENV_ARGS=/usr/bin/ksh

export CC="cc -qcpluscmt -D_LARGE_FILES"

./configure \
    --prefix=%{_prefix} \
    --mandir=%{_mandir} \
    --with-openssl=%{_prefix} \
    --with-pcre=%{_prefix} \
    --enable-shared --disable-static

make %{?_smp_mflags}


%install
[ "${RPM_BUILD_ROOT}" != "/" ] && rm -rf ${RPM_BUILD_ROOT}
make install DESTDIR=${RPM_BUILD_ROOT}

/usr/bin/strip ${RPM_BUILD_ROOT}%{_sbindir}/* || :

# make directory tree for cfengine configs
mkdir -p ${RPM_BUILD_ROOT}/var/%{name}
for i in ppkeys inputs outputs ; do
    mkdir -m 0700 ${RPM_BUILD_ROOT}/var/%{name}/$i
done

# It's ugly, but thats the way Mark wants to have it. :(
# If we don't create this link, cfexecd will not be able to start
# (hardcoded) /var/sbin/cfagent in scheduled intervals. Other option 
# would be to patch cfengine to use %{_sbindir}/cfagent
mkdir -p ${RPM_BUILD_ROOT}/var/%{name}/bin
ln -sf %{_sbindir}/cfagent ${RPM_BUILD_ROOT}/var/%{name}/bin/

# All this stuff is pushed into doc/contrib directories
rm -rf ${RPM_BUILD_ROOT}%{_datadir}/%{name} 
rm -f ${RPM_BUILD_ROOT}%{_sbindir}/cfdoc

# Startup files for cf-execd, cf-monitord and cf-serverd
mkdir -p ${RPM_BUILD_ROOT}/etc/rc.d/init.d
mkdir -p ${RPM_BUILD_ROOT}/etc/rc.d/rc2.d
mkdir -p ${RPM_BUILD_ROOT}/etc/rc.d/rc3.d
cp %{SOURCE1} ${RPM_BUILD_ROOT}/etc/rc.d/init.d/cf-execd
cp %{SOURCE2} ${RPM_BUILD_ROOT}/etc/rc.d/init.d/cf-monitord
cp %{SOURCE3} ${RPM_BUILD_ROOT}/etc/rc.d/init.d/cf-serverd
chmod 0755 ${RPM_BUILD_ROOT}/etc/rc.d/init.d/*

ln -sf '../init.d/cf-execd' ${RPM_BUILD_ROOT}/etc/rc.d/rc2.d/Kcf-execd
ln -sf '../init.d/cf-execd' ${RPM_BUILD_ROOT}/etc/rc.d/rc2.d/Scf-execd
ln -sf '../init.d/cf-execd' ${RPM_BUILD_ROOT}/etc/rc.d/rc3.d/Kcf-execd
ln -sf '../init.d/cf-execd' ${RPM_BUILD_ROOT}/etc/rc.d/rc3.d/Scf-execd

ln -sf '../init.d/cf-monitord' ${RPM_BUILD_ROOT}/etc/rc.d/rc2.d/Kcf-monitord
ln -sf '../init.d/cf-monitord' ${RPM_BUILD_ROOT}/etc/rc.d/rc2.d/Scf-monitord
ln -sf '../init.d/cf-monitord' ${RPM_BUILD_ROOT}/etc/rc.d/rc3.d/Kcf-monitord
ln -sf '../init.d/cf-monitord' ${RPM_BUILD_ROOT}/etc/rc.d/rc3.d/Scf-monitord

ln -sf '../init.d/cf-serverd' ${RPM_BUILD_ROOT}/etc/rc.d/rc2.d/Kcf-serverd
ln -sf '../init.d/cf-serverd' ${RPM_BUILD_ROOT}/etc/rc.d/rc2.d/Scf-serverd
ln -sf '../init.d/cf-serverd' ${RPM_BUILD_ROOT}/etc/rc.d/rc3.d/Kcf-serverd
ln -sf '../init.d/cf-serverd' ${RPM_BUILD_ROOT}/etc/rc.d/rc3.d/Scf-serverd

cd ${RPM_BUILD_ROOT}
mkdir -p usr/sbin
cd usr/sbin
ln -sf ../..%{_sbindir}/* .


%post
# cfagent won't run nicely, unless your host has keys.
if [ ! -f /var/%{name}/ppkeys/localhost.priv ] ; then
    %{_sbindir}/cf-key >/dev/null || :
fi


%preun
if [ "$1" = "0" ] ; then
    /etc/rc.d/init.d/cf-monitord  stop || :
    /etc/rc.d/init.d/cf-execd stop || :
    /etc/rc.d/init.d/cf-serverd stop || :
fi


%postun
if [ $1 -ge 1 ] ; then
    /etc/rc.d/init.d/cf-monitord  restart || :
    /etc/rc.d/init.d/cf-execd restart || :
    /etc/rc.d/init.d/cf-serverd restart || :
fi


%clean
[ "${RPM_BUILD_ROOT}" != "/" ] && rm -rf ${RPM_BUILD_ROOT}


%files
%defattr(-,root,system,-)
%doc AUTHORS ChangeLog README
%{_sbindir}/*
%{_libdir}/libpromises*
%{_mandir}/man8/*
/etc/rc.d/init.d/cf-execd
/etc/rc.d/rc2.d/Scf-execd
/etc/rc.d/rc3.d/Scf-execd
/etc/rc.d/rc2.d/Kcf-execd
/etc/rc.d/rc3.d/Kcf-execd
/etc/rc.d/init.d/cf-monitord
/etc/rc.d/rc2.d/Scf-monitord
/etc/rc.d/rc3.d/Scf-monitord
/etc/rc.d/rc2.d/Kcf-monitord
/etc/rc.d/rc3.d/Kcf-monitord
/etc/rc.d/init.d/cf-serverd
/etc/rc.d/rc2.d/Scf-serverd
/etc/rc.d/rc3.d/Scf-serverd
/etc/rc.d/rc2.d/Kcf-serverd
/etc/rc.d/rc3.d/Kcf-serverd
/var/%{name}
/usr/sbin/*


%files doc
%defattr(-,root,system,-)
%doc masterfiles
%doc docs/*html


%changelog
* Mon Jun 04 2012 Michael Perzl <michael@perzl.org> - 3.2.4-2
- rebuilt against correct version of openssl

* Tue Apr 10 2012 Michael Perzl <michael@perzl.org> - 3.2.4-1
- updated to version 3.2.4

* Fri Oct 28 2011 Michael Perzl <michael@perzl.org> - 3.2.3-1
- updated to version 3.2.3

* Fri Oct 28 2011 Michael Perzl <michael@perzl.org> - 3.2.1-1
- updated to version 3.2.1

* Wed May 25 2011 Michael Perzl <michael@perzl.org> - 3.1.5-1
- updated to version 3.1.5

* Tue Feb 15 2011 Michael Perzl <michael@perzl.org> - 3.1.4-1
- updated to version 3.1.4

* Tue Feb 15 2011 Michael Perzl <michael@perzl.org> - 3.1.1-2
- fixed the init scripts and %pre and %post scripts

* Thu Nov 25 2010 Michael Perzl <michael@perzl.org> - 3.1.1-1
- updated to version 3.1.1

* Thu Nov 25 2010 Michael Perzl <michael@perzl.org> - 2.2.10-2
- fixed a typo in the %post scripts

* Thu Feb 18 2010 Michael Perzl <michael@perzl.org> - 2.2.10-1
- first version for AIX V5.1 and higher
